% This program is related to the example of turbo codes of chapter 7, 

% Authors: Damian Gustavo Levin, Patrick Farrell and Jorge Castieira 
% 5/10/2003
% updated 03/11/2006
%--------------------------------------------------------------------------------------------
% this program is intended for academic proposes, and it is not optimised
% in terms of the programing style

clear all;
close all;
Errores=0;
Mat=zeros(4,4,3);

% Mat is an array that contains the trellis information
% the first column contains the input data, the second column contains the first output 
%(systematic bit) and the third column conains the second output
%(redundancy bit). This is the trellis of the SRC (7,5) code of figure 7.14 in chapter 7
%branch of the trellis described by the pair (current state, next state)
%Mat(current state, next state, 1)= value of the input bit that is associated to this branch 
% for the input or systematic bit

Mat(1,1,1)= -1; Mat(1,2,1)= +1;                     
Mat(2,3,1)= -1; Mat(2,4,1)= +1;
Mat(3,1,1)= +1; Mat(3,2,1)= -1;
Mat(4,3,1)= +1; Mat(4,4,1)= -1;

% first output bit of the SRC placed at column 2, Mat(current state, next
% state, 2)

Mat(1,1,2)= -1; Mat(1,2,2)= +1;                     
Mat(2,3,2)= -1; Mat(2,4,2)= +1;
Mat(3,1,2)= +1; Mat(3,2,2)= -1;
Mat(4,3,2)= +1; Mat(4,4,2)= -1;

% second output bit of the SRC placed at column 3, Mat(current state, next
% state, 3)
Mat(1,1,3)= -1; Mat(1,2,3)= +1;                       
Mat(2,3,3)= +1; Mat(2,4,3)= -1;
Mat(3,1,3)= +1; Mat(3,2,3)= -1;
Mat(4,3,3)= -1; Mat(4,4,3)= +1;

%Numerical Constants 

N=16;     % length of the block to be encoded

Inter=[1 5 9 13 2 6 10 14 3 7 11 15 4 8 12 16];  %Block interleaver, N=16

 
for g=1:1;    % This loop runs the encoding of a block gmax times   
   
	InputBits =[1.0000000e+000
  1.0000000e+000
 -1.0000000e+000
  1.0000000e+000
  1.0000000e+000
 -1.0000000e+000
  1.0000000e+000
  1.0000000e+000
 -1.0000000e+000
  1.0000000e+000
  1.0000000e+000
  1.0000000e+000
 -1.0000000e+000
  1.0000000e+000
 -1.0000000e+000
 -1.0000000e+000];

		
   	InputBits2(:,1)= InputBits(Inter(:),1);    % Interleaving of the input message to be input 
                                              % to the second encoder
    
	Sigma = 1.2; %Transmited bits are affected by AWGN, function randn performs this step
	Lc = 2/(Sigma^2);                % Lc=4.Eb/(2.Sigma^2),   with  Eb=1

	% In the following the received sequences for each decoder, Y1 and Y2, are formed
    % taking into account the interleaving and puncturing procedures
   
   Y1=zeros(N,2);
   
	ReceivedBits=[ 2.1307172e-001  3.6411951e-001
 -3.7084174e-001 -3.5066586e-001
  1.3884661e-001  1.8180640e+000
  5.1447006e-001  1.6462774e+000
  5.3880502e-001  3.8795747e-001
 -4.2157566e-001 -2.5865329e+000
  1.5325292e+000  2.6720925e-001
  1.4573202e+000 -1.6783709e+000
  3.2281809e-001  1.1034100e+000
  2.0277362e+000 -1.7019835e-001
 -4.1421059e-001  3.5605010e+000
  1.4823635e+000 -1.0034367e+000
 -1.7010732e+000  8.9257225e-001
 -1.7538339e-001 -1.3059783e+000
 -8.6187254e-001 -2.0490546e+000
 -9.1783489e-001 -4.9248647e-001
];
   
     
   Y2=Y1;
	Y1=ReceivedBits;
	for i= 2:2:N
   	Y1(i,2)=0;   % A zero is placed at the even positions for the first decoder, 
    end            %this takes into account the puncturing

	for i= 1:N;
   	Y2(i,1)= ReceivedBits(Inter(i),1);       %Received sequence is interleaved for the second decoder
   end
      
	for i=2:2:N
   	Y2(i,2)=ReceivedBits(i,2);
	end
   	Y2
    pause;
	%The following is the logmap BCJR decoder operation
    
	Luk = zeros(N,1); %initialization of the a priori infomation Luk
	Gama= zeros(N,4,4);%initialization of coefficients gamma

for h=1:7;      %iterative decoding Loop
                    %Each loop is related to the operation of one of the decoders
Luk
pause;  
      if mod(h,2)==1;%decision about the decoder that has to operate
      	Y=Y1;
   	else
      	Y=Y2; 
   	end
      	 
   	for i= 1:N;  %Coefficients gamma are here calculated
      	for k= 1:4;
         	for j= 1:4;
            	if Mat(j,k,1)~=0;
               	Gama(i,j,k)= exp(Mat(j,k,1).*Luk(i)/2).*exp(Lc/2*(Y(i,1).*Mat(j,k,2)+Y(i,2).*Mat(j,k,3)));
            	end
         	end
      	end
    end

Gama
pause;

   	Alfa=zeros(N,4);  % %Coefficients alfa are here calculated
   	Alfa(1,1)=1;   
   	for i=2:N;
      	for k=1:4;
         	for j=1:4;
            	Alfa(i,k)=Alfa(i,k)+(Gama(i-1,j,k).*Alfa(i-1,j));
         	end
      	end
   	end
      	   
   	Beta=zeros(N+1,4);   % %Coefficients beta are here calculated, they are all first set to 0
   	if mod(h,2)==1;
      	Beta(N+1,1)=1;    %For the first decoder, Beta(N+1,1) should be 1 y and he others should be 0
   	else
      	Beta(N+1,:)=1;    %For the second decoder all the beta values are 1
      end                  % because encoder 2 produces a non terminated sequence   
   	for i=N:-1:2;
      	for k=1:4;
         	for j=1:4;
            	Beta(i,k)=Beta(i,k)+(Beta(i+1,j).*Gama(i,k,j));
         	end
      	end
   	end
      
   	Luky=zeros(N,1);   % Luky is the conditional estimation L(b(i)/y)
   	for i=1:N;
      	Numer=0;
      	Denom=0;
      	for k=1:4;
         	for j=1:4;
            	if Mat(j,k,1)==1;
               	Numer = Numer + (Alfa(i,j).*Gama(i,j,k).*Beta(i+1,k));
            	elseif Mat(j,k,1)==-1;
               	Denom = Denom + (Alfa(i,j).*Gama(i,j,k).*Beta(i+1,k));
            	end
         	end      
      	end
      	Luky(i)=log(Numer/Denom); %Estimations of the bits
   	end
     	LukyHard=sign(Luky);    %Hard decision at the coresponding iteration 
                                %is the sign of the bit estimation
Luky
pause;   
             
   	% Calculation of the extrinsic information to be passed to the other
   	% decoder
   
  Le(:,1) = Luky(:,1) - Lc.*Y(:,1) - Luk(:,1);
  
  Le
  pause;
   	
Luk(:)= Le(Inter(:));  % De-interleaving of the extrinsic information 
                       % that is the a priori information passed to the
                       %other decoder
       
	   
end      %End of the iterative decoding loop 

Errores= Errores + sum(abs(LukyHard-InputBits)/2);
   
end         % End of the loop of variable g 

Errores